POJ3126——Prime Path

来源:互联网 发布:javascript设计模式pdf 编辑:程序博客网 时间:2024/06/08 06:44
Prime Path
Time Limit: 1000MS Memory Limit: 65536KTotal Submissions: 17409 Accepted: 9800

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

31033 81791373 80171033 1033

Sample Output

670

Source

Northwestern Europe 2006


题目大意:T组测试数据,每组有 两个素数 a 和 b , 求从 a 变到 b ,每次变一个数,并且新的四位数也必须是素数,当变到 b 的时候一共变了几次,输出次数,如果不能变到 b ,则输出  Impossible

 思路:

每一位的搜索+素数判定,个位肯定不能为偶数,千位不能为0;


Memory: 780KTime: 32MSLanguage: G++Result: AcceptedSource Code#include <iostream>#include <queue>#include <cstring>using namespace std;struct node{    int data;    int step;};const int MX = 11000;int a, b;int vis[MX];     //标记数组bool check( int x )     //素数判定{    if( x==2||x==3 )        return true;    else if( x<=1||x%2==0 )        return false;    else    {        for( int i = 3;i*i<=x;i=i+2 )        {            if( x%i==0 )                return false;        }        return true;    }}void bfs(){    queue<struct node> q;    while(!q.empty())        q.pop();        struct node x;    x.data = a;    x.step = 0;    q.push(x);    vis[a] = 1;    while( !q.empty() )    {        x = q.front();        q.pop();        if( x.data==b )     //当到达 b 的时候,输出步数,跳出        {            cout<<x.step<<endl;            return;        }        int gewei = x.data%10;       //取个位数,为了后来用起来方便        int shiwei = (x.data/10)%10;    //取十位数,同理        for( int i = 1;i <= 9;i = i+2 )      //遍历个位数,不能为偶数        {            int t = (x.data/10)*10 + i;            if( t!=x.data&&!vis[t]&&check(t) )            {                vis[t] = 1;                struct node y;                y.data = t;                y.step = x.step+1;                q.push(y);            }        }        for( int i = 0;i <= 9;i++ )          //遍历十位数        {            int t = (x.data/100)*100 + i*10 + gewei;            if( t!=x.data&&!vis[t]&&check(t) )            {                vis[t] = 1;                struct node y;                y.data = t;                y.step = x.step+1;                q.push(y);            }        }        for( int i = 0;i <= 9;i++ )    //遍历百位数        {            int t = (x.data/1000)*1000 + i*100 + shiwei*10 + gewei;            if( t!=x.data&&!vis[t]&&check(t) )            {                vis[t] = 1;                struct node y;                y.data = t;                y.step = x.step+1;                q.push(y);            }        }        for( int i = 1;i <= 9;i++ )     //遍历千位数,不能为0        {            int t = i*1000 + x.data%1000;            if( t!=x.data&&!vis[t]&&check(t) )            {                vis[t] = 1;                struct node y;                y.data = t;                y.step = x.step+1;                q.push(y);            }        }    }    cout<<"Impossible"<<endl;      //不能到达   b    return;}int main(){    int test;    cin>>test;    while(test--)    {        cin>>a>>b;        memset(vis,0,sizeof(vis));      //标记数组初始化0        bfs();    }    return 0;}



0 0
原创粉丝点击